Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2322 by niro, Fri Jan 3 13:18:57 2014 UTC revision 2472 by niro, Wed Jan 8 08:52:28 2014 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/bash
2  # $Id$  # $Id$
3  #  #
4  # Simple Installation Script  # Simple Installation Script
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  #images: (get ${CDIMAGENAME})  # setup locales
11  source /mnt/cdrom/system/images.conf  TEXTDOMAIN=installer
12    LC_MESSAGES=C
13    
14  #Includes  # include dir
15  source /usr/lib/installer/functions/findhdd.sh > /dev/null  INSTALLER_LIBDIR="%LIBDIR%"
 ### bugfix ###############################  
 cdromdev="$(echo ${cdromdev} | sed 's/ //')"  
 ########################################  
16    
17  ### System/Config Version  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
18  VERSION="%VERSIONTAG%"  # -> now in images.conf
19  TITLE="Installer - ${VERSION}"  CURRENTLINE=0
20    
21    die()
22    {
23     echo "Error: $@"
24     exit 1
25    }
26    
27  CDPATH="/mnt/cdrom"  # load common includes
28  INSTALLPATH="/mnt/magellan"  for inc in %SYSCONFDIR%/installer.conf \
29     ${INSTALLER_LIBDIR}/functions/common.sh \
30     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
31     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
32     ${INSTALLER_LIBDIR}/functions/bootloader.sh \
33     ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
34     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
35    do
36     if [ -e ${inc} ]
37     then
38     source "${inc}"
39     else
40     die "'${inc}' not found"
41     fi
42    done
43    
44  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
45    # -> now in images.conf
46    CDIMAGENAME=""
47    TOTALLINES=""
48  CURRENTLINE=0  CURRENTLINE=0
49  #TOTALLINES=11072 # -> now in images.conf  if [ -e /mnt/cdrom/system/images.conf ]
50    then
51     source /mnt/cdrom/system/images.conf
52     # check if all required variables are set
53     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
54     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
55    else
56     die "/mnt/cdrom/system/images.conf not found"
57    fi
58    
59  # standard kernel opts  ### System/Config Version
60  KERNELOPTS="quiet video=1024x768"  VERSION="%VERSIONTAG%"
61    TITLE="${DEFAULT_TITLE} - ${VERSION}"
62    
63  # grub options  # some sane defaults
64    CDROOT="${DEFAULT_CDROOT}"
65    INSTALLROOT="${DEFAULT_INSTALLROOT}"
66    KERNELPKG="${DEFAULT_KERNELPKG}"
67    KERNELOPTS="${DEFAULT_KERNELOPTS}"
68  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
69  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
70  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
71  SPECIALDEVICE=""  SPECIALDEVICE=""
72  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
73    FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
 # target filesystem  
 FORMAT_FILESYSTEM="ext4"  
74    
75  #################################################  #################################################
76  #  DIALOG BOXEN #  #  DIALOG BOXEN #
77  #################################################  #################################################
78    
79  die()  trap_exit()
80  {  {
81   ERROR=$1   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
82   RETVAL=$?   is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
83     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
84     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
85     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
86    
87     echo $"Installation aborted."
88     exit 1
89    }
90    
91    dialog_die()
92    {
93     ERROR="$1"
94     RETVAL="$?"
95   dialog_install_failure   dialog_install_failure
96   exit 1   exit 1
97  }  }
98    
99  dialog_warning()  dialog_warning()
100  {  {
101   dialog \   local retval
102   --backtitle "${TITLE}" \  
103   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
104   --defaultno \   retval=$?
105   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
106   then   then
107   clear   clear
108   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
109   exit 1   exit 1
110   fi   fi
111  }  }
112    
113  dialog_setup_hdd_info()  dialog_setup_hdd_info()
114  {  {
115   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
116    
117   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
118   --colors \   $"Please create 1 partition.\n\n[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace.\nPlease mark ${SHDD}1 \Z3bootable\Zn."
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
119  }  }
120    
121  dialog_setup_hdd_info_auto()  dialog_setup_hdd_info_auto()
122  {  {
123   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
124    
125   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
126   --colors \   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
127  }  }
128    
129  dialog_setup_system_menu()  dialog_setup_system_menu()
130  {  {
131   local i   local mode
132     local retval
133    
134   i=$(dialog \   mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \
135   --backtitle "${TITLE}" \   $"1:Automatic setup (recommended)" \
136   --title "[ Festplatten Partitionierung ]" \   ":" \
137   --cancel-label "Abbrechen" \   $":\Z1Expert modes:\Zn" \
138   --ok-label "Weiter" \   $"2:Common IDE-disk (manual setup)")
139   --stdout \   retval=$?
140   --colors \   [[ ${retval} -eq 1 ]] && return 1
141   --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \   if [[ ${retval} -eq 0 ]]
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
142   then   then
143   case "${i}" in   case "${mode}" in
144   "1") run_install_auto ;;   "1") run_install_auto ;;
145           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
146   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
147   esac   esac
148   fi   fi
# Line 149  dialog_setup_system_menu() Line 150  dialog_setup_system_menu()
150    
151  dialog_hardware_detection()  dialog_hardware_detection()
152  {  {
153   local i   local message
  local hwtmp  
   
  if [ -x $(which mktemp &> /dev/null) ]  
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
154    
155   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
156    
157   echo "dialog \\"  > ${hwtmp}   message+=$"Harddrives:\n"
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
158    
159   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
160   then   then
161   for i in ${scsidisks}   for i in ${ALL_DISKS}
162   do   do
163   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn "
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
164   done   done
165     message+="\n"
166   fi   fi
167    
168   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
169   then   then
170   for i in ${idedisks}   message+="\n"
171     message+=$"Optical disk drives:\n"
172     for i in ${ALL_CDROMS}
173   do   do
174   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn"
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
175   done   done
176   fi   message+="\n"
   
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
177   fi   fi
178    
179   # other devices   # other devices
180   run_hardware_detection   run_hardware_detection
181   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
182   zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;   zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
183   rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;   rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
184   maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;   maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
185   *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;   *) message+=$"\n\ZnCommon device detected.\Zn" ;;
186   esac   esac
187   if [[ ${FORMFACTOR} = laptop ]]   if [[ ${FORMFACTOR} = laptop ]]
188   then   then
189   echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
190   fi   fi
191    
192   echo " \" 14 70" >> ${hwtmp}   messagebox -y 12 -h $"Detected hardware:" "${message}"
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
193  }  }
194    
195  dialog_setup_hdd_partitions_manuell()  dialog_setup_hdd_partitions_manual()
196  {  {
197   local i   local i
198     local retval
199    
200   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
201   then   then
202   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
203   exit 1   exit 1
204   else   else
205     HDD=$(dialog_select_target_harddrive)
206   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
207   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
208   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
209   then   then
210   dialog_setup_hdd_info   dialog_setup_hdd_info
211   setup_hdd_partitions_manuell   setup_hdd_partitions_manual
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell_flash()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_flash  
  setup_hdd_partitions_manuell_flash  
212   fi   fi
213   fi   fi
214  }  }
# Line 303  dialog_setup_hdd_partitions_manuell_flas Line 216  dialog_setup_hdd_partitions_manuell_flas
216  dialog_setup_hdd_partitions_auto()  dialog_setup_hdd_partitions_auto()
217  {  {
218   local i   local i
219     local retval
220    
221   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
222   then   then
223   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
224   exit 1   exit 1
225   else   else
226     HDD=$(dialog_select_target_harddrive)
227   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
228   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
229   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
230   then   then
231   dialog_setup_hdd_info_auto   dialog_setup_hdd_info_auto
232   dialog_setup_hdd_create_partitions   dialog_setup_hdd_create_partitions
# Line 339  dialog_setup_hdd_partitions_auto() Line 235  dialog_setup_hdd_partitions_auto()
235   fi   fi
236  }  }
237    
238  dialog_setup_hdd_create_partitions()  install_meter()
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Disk Partitionen ..." 3 70  
 }  
   
 dialog_setup_hdd_format()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Datei-Systeme ..." 3 70  
 }  
   
 dialog_install_settings()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Speichere System-Einstellungen ..." 3 70  
 }  
   
 dialog_install_system_image()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --gauge "Kopiere System-Image ..." 6 80  
 }  
   
 dialog_install_meter()  
239  {  {
240   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
241   do   do
# Line 380  dialog_install_meter() Line 248  dialog_install_meter()
248   return 0   return 0
249  }  }
250    
   
 dialog_install_bootsector()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Schreibe den Bootsektor ..." 3 70  
 }  
   
 dialog_install_successful()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81  
 }  
   
 dialog_install_failure()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\  
  Fehler bei ${ERROR}, RetVal: ${RETVAL} \  
  " 10 81  
 }  
   
251  dialog_main()  dialog_main()
252  {  {
253   METHOD=0   local method=0
254     local retval
255    
256   while [[ ${METHOD} -le 2 ]]   while [[ ${method} -le 2 ]]
257   do   do
258   METHOD=$(dialog \   method=$(CANCEL_LABEL=$"Exit" menubox $"Configuration:" \
259   --backtitle "${TITLE}" \   $"1:Install system" \
260   --no-cancel \   $"2:Show detected harddrives" \
261   --ok-label "Weiter" \   $"3:Exit and reboot" \
262   --stdout \   $"4:Exit and drop into a shell")
263   --menu "Konfiguration" 14 70 5 \   retval=$?
264   "1" "AutoSta_LX installieren" \   [[ ${retval} -eq 1 ]] && exit 1
265   "2" "Uebersicht gefundener Laufwerke" \   if [[ ${retval} -eq 0 ]]
  "3" "Beenden und neustarten" \  
  "4" "Beenden und eine Shell starten")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && exit 1  
  if [[ ${RES} -eq 0 ]]  
266   then   then
267   case ${METHOD} in   case ${method} in
268           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
269   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
270   "3") install_do_reboot ;;   "3") install_do_reboot ;;
271   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 445  run_hardware_detection() Line 283  run_hardware_detection()
283    
284   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
285    
286   # check for special devices/clients:   ## check for special devices/clients:
287   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
288   local removable=0   #local removable=0
289   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
290   then   #then
291   for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
292   do   #do
293   if [[ $(< ${i}) = 1 ]]   #if [[ $(< ${i}) = 1 ]]
294   then   #then
295   removable=1   #removable=1
296   fi   #fi
297   done   #done
298     ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
299   # only add this for grub legacy, grub2 detect these settings on its own  
300   export GRUBLEGACYOPTS="rootdelay=8"   ## only add this for grub legacy, grub2 detect these settings on its own
301   # there are to zotac types in the wild, nvidia based gfx and intel   #export GRUBLEGACYOPTS="rootdelay=8"
302   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   ## there are to zotac types in the wild, nvidia based gfx and intel
303   then   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
304   export SPECIALDEVICE="zotac_nvidia"   #then
305   else   #export SPECIALDEVICE="zotac_nvidia"
306   export SPECIALDEVICE="zotac_intel"   #else
307   fi   #export SPECIALDEVICE="zotac_intel"
308   fi   #fi
309     #fi
310    
311   # check for special devices/clients:   # check for special devices/clients:
312   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 496  run_hardware_detection() Line 335  run_hardware_detection()
335   fi   fi
336  }  }
337    
338    run_hardware_detection_disks()
339    {
340     local bootdev
341    
342     # all disks but exclude ramdisks
343     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
344     # remove the boot device from ALL_DISKS if it was an usbstick
345     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
346     then
347     bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
348     export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
349     fi
350     export ALL_CDROMS="$(get_hwinfo cdrom)"
351    }
352    
353  hdd_size_below_256mb()  hdd_size_below_256mb()
354  {  {
355   local hdd="$1"   local hdd="$1"
356   local size   local size
357   local retval   local retval
358   [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"   [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
359    
360   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
361   if [[ ${size} -le 257000000 ]]   if [[ ${size} -le 257000000 ]]
# Line 518  setup_hdd_partitions_auto() Line 372  setup_hdd_partitions_auto()
372  {  {
373   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
374    
375     # sanity check - should not happen
376     if is_mounted --device "${ROOTHDD}"
377     then
378     echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
379     umount "${ROOTHDD}"
380     fi
381    
382   # run this only if FDISKPARTITIONBELOW256MB is not already 1   # run this only if FDISKPARTITIONBELOW256MB is not already 1
383   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
384   then   then
# Line 530  setup_hdd_partitions_auto() Line 391  setup_hdd_partitions_auto()
391   fi   fi
392    
393   ## delete disk   ## delete disk
394   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
395    
396   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
397   then   then
# Line 576  EOF Line 437  EOF
437   fi   fi
438  }  }
439    
440  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
441  {  {
442   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
443     SWAPHDD=""
444   ## hdds partitionieren manuell   BOOTHDD=""
445   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
446  }  }
447    
448  setup_hdd_format()  setup_hdd_format()
449  {  {
450   mkswap ${SWAPHDD} || die   # sanity check - should not happen
451   mke2fs -j -q ${BOOTHDD} || die   if is_mounted --device "${ROOTHDD}"
452   mke2fs -j -q ${ROOTHDD} || die   then
453  }   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
454     umount "${ROOTHDD}"
455     fi
456    
457  setup_hdd_format_flash()   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
 {  
  mke2fs -j -q ${ROOTHDD} || die  
458  }  }
459    
460  install_mount_rootfs()  install_mount_rootfs()
461  {  {
462   swapon ${SWAPHDD} || die   is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"
463   mount ${ROOTHDD} ${INSTALLPATH} || die   install -d ${INSTALLROOT}/boot || dialog_die
  install -d ${INSTALLPATH}/boot || die  
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
464  }  }
465    
466  install_system_image()  install_system_image()
467  {  {
468   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   pushd ${INSTALLROOT} > /dev/null
469     tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
470     popd > /dev/null
471  }  }
472    
473  install_bootsector_chroot()  disabled_install_bootsector_chroot()
474  {  {
475   local my_roothdd   local my_roothdd
476   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf="${INSTALLROOT}/boot/grub/grub.conf"
477   local grub2conf=/boot/grub/grub.cfg   local grub2conf="/boot/grub/grub.cfg"
478    
479   # check for grub2   # check for grub2
480   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
481   then   then
482   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
483   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
484   then   then
485   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
486   fi   fi
487    
488   # set kernelopts   # set kernelopts
489   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
490   then   then
491   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
492   else   else
493   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die   CONFIG="${INSTALLROOT}/etc/conf.d/grub"
494   fi   clearconfig
495   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die   addconfig "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\""
496   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   fi
497   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   CONFIG="${INSTALLROOT}/root/.installrc"
498   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die   clearconfig
499     # only grub 1.99
500     addconfig 'type -P grub-mkdevicemap && grub-mkdevicemap'
501     addconfig "grub-install --no-floppy ${HDD} &> /dev/null"
502     addconfig "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null"
503     addconfig "exit 0"
504    
505   # grub-legacy   # grub-legacy
506   else   else
507   ### grubconf schreiben   source ${INSTALLROOT}/boot/kernelversion
  source ${INSTALLPATH}/boot/kernelversion  
508    
509   #for alx only   if [ -e ${INSTALLROOT}/etc/alx_version ]
  if [ -e ${INSTALLPATH}/etc/alx_version ]  
510   then   then
511   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
512   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
513   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
514   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
515   fi   fi
# Line 673  install_bootsector_chroot() Line 519  install_bootsector_chroot()
519   [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"   [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"
520    
521   # uuid support   # uuid support
522   if is_uuid_supported   my_roothdd="UUID=$(get_uuid ${ROOTHDD})"
  then  
  my_roothdd="UUID=$(get_uuid ${ROOTHDD})"  
  else  
  my_roothdd="${ROOTHDD}"  
  fi  
523    
524   : > ${grubconf} || die   CONFIG="${grubconf}"
525   echo "default 0" >> ${grubconf} || die   clearconfig
526   echo "timeout 3" >> ${grubconf} || die   addconfig "default 0"
527     addconfig "timeout 3"
528   # using current root password   # using current root password
529   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die   addconfig "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"
530    
531   echo  >> ${grubconf} || die   addconfig
532   echo "# normal boot" >> ${grubconf} || die   addconfig "# normal boot"
533   echo "title ${KRNVER}" >> ${grubconf} || die   addconfig "title ${KRNVER}"
534   echo "root (hd0,0)" >> ${grubconf} || die   addconfig "root (hd0,0)"
535   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die   addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}"
536   if is_initrd_supported   if is_initrd_supported
537   then   then
538   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   addconfig "initrd /boot/${KRNINITRD}"
539   fi   fi
540    
541   echo >> ${grubconf} || die   addconfig
542   echo "# admin boot" >> ${grubconf} || die   addconfig "# admin boot"
543   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die   addconfig "title ${KRNVER} - Re-run hardware-detection"
544   echo "lock"  >> ${grubconf} || die   addconfig "lock"
545   echo "root (hd0,0)" >> ${grubconf} || die   addconfig "root (hd0,0)"
546   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die   addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection"
547   if is_initrd_supported   if is_initrd_supported
548   then   then
549   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   addconfig "initrd /boot/${KRNINITRD}"
550   fi   fi
551    
552   echo >> ${grubconf} || die   addconfig
553   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die   addconfig "title ${KRNVER} - Reset *all* local settings"
554   echo "lock"  >> ${grubconf} || die   addconfig "lock"
555   echo "root (hd0,0)" >> ${grubconf} || die   addconfig "root (hd0,0)"
556   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die   addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings"
557   if is_initrd_supported   if is_initrd_supported
558   then   then
559   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   addconfig "initrd /boot/${KRNINITRD}"
560   fi   fi
561    
562   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
563   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
564  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
565  root (hd0,0)  root (hd0,0)
566  setup (hd0)  setup (hd0)
# Line 728  exit 0 Line 570  exit 0
570  CHROOTEOF  CHROOTEOF
571   fi   fi
572    
573   ## enters chroot   # run installrc
574   mount -t proc proc ${INSTALLPATH}/proc   chrooted /bin/bash --rcfile /root/.installrc -i
575   mount -t sysfs sysfs ${INSTALLPATH}/sys   rm ${INSTALLROOT}/root/.installrc
  mount -o bind /dev ${INSTALLPATH}/dev  
  chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLPATH}/proc  
  umount ${INSTALLPATH}/sys  
  umount ${INSTALLPATH}/dev  
  rm ${INSTALLPATH}/root/.installrc  
 }  
   
 is_initrd_supported()  
 {  
  # only generate initrds if the cmd exists  
  [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0  
  return 1  
576  }  }
577    
578  install_initrd_chroot()  disabled_install_initrd_chroot()
579  {  {
580   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
581   is_initrd_supported || return 0   is_initrd_supported || return 0
# Line 773  install_initrd_chroot() Line 602  install_initrd_chroot()
602   fi   fi
603    
604   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
605   install -d ${INSTALLPATH}/etc/modprobe.d || die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
606   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die   CONFIG="${INSTALLROOT}/etc/modprobe.d/uvesafb.conf"
607     clearconfig
608     addconfig "options uvesafb mode_option=1024x768-32@60 scroll=ywrap"
609    
610   # install an appropriate viafb.conf   # install an appropriate viafb.conf
611   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die   CONFIG="${INSTALLROOT}/etc/modprobe.d/viafb.conf"
612     clearconfig
613     addconfig "options viafb viafb_mode=1024x768 viafb_refresh=60"
614    
615   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
616   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die   CONFIG="${INSTALLROOT}/etc/modprobe.d/i810fb.conf"
617     clearconfig
618     addconfig "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"
619    
620   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
621  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
622  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
623  exit 0  exit 0
624  CHROOTEOF  CHROOTEOF
625    
626   ## enters chroot   # run installrc
627   mount -t proc proc ${INSTALLPATH}/proc   chrooted /bin/bash --rcfile /root/.installrc -i
628   mount -t sysfs sysfs ${INSTALLPATH}/sys   rm ${INSTALLROOT}/root/.installrc
  mount -o bind /dev ${INSTALLPATH}/dev  
  chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLPATH}/proc  
  umount ${INSTALLPATH}/sys  
  umount ${INSTALLPATH}/dev  
  rm ${INSTALLPATH}/root/.installrc  
 }  
   
 is_uuid_supported()  
 {  
  if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]  
  then  
  # only detect uuids if supported  
  if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]  
  then  
  return 0  
  fi  
  fi  
   
  return 1  
 }  
   
 get_uuid()  
 {  
  local UUID  
  local SEC_TYPE  
  local TYPE  
   
  local dev="$1"  
  [[ -z ${dev} ]] && die "no dev given"  
   
  # check if given device is already an UUID  
  if [[ ${dev/UUID=/}x != ${dev}x ]]  
  then  
  eval "${dev}"  
  else  
  eval $(busybox.mkinitrd blkid ${dev} | grep "${dev}:" | sed 's/.*:\ //')  
  fi  
  echo "${UUID}"  
629  }  }
630    
631  install_system_settings()  install_system_settings()
632  {  {
633   # schreibe fstab   local CONFIG
634   if is_uuid_supported  
635   then   # write fstab
636   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   CONFIG="${INSTALLROOT}/etc/fstab"
637   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die   clearconfig
638   else   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
639   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
640   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
  fi  
  # not needed busybox loads all with swapon -a, even if not mentioned in fstab  
  #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
641    
642   # install network config skeleton   # install network config skeleton
643   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die   CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
644     clearconfig
645     addconfig 'ONBOOT="yes"'
646     addconfig 'NETWORKING="dhcp"'
647    
648   # intel framebufer quirk   # intel framebuffer quirk
649   if [[ -e /proc/fb ]]   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]
650   then   then
651   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   if [ -e /proc/fb ]
652   then   then
653   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
  if [[ ${fbdev} != 0 ]]  
654   then   then
655   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
656     if [[ ${fbdev} != 0 ]]
657     then
658     sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
659     fi
660   fi   fi
661   fi   fi
662   fi   fi
663  }  }
664    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
 }  
   
665  install_umount_rootfs()  install_umount_rootfs()
666  {  {
667   cd /   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
668   umount ${INSTALLPATH}/boot || die   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
  umount ${INSTALLPATH} || die  
  swapoff ${SWAPHDD} || die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || die  
669  }  }
670    
671  install_do_reboot()  install_do_reboot()
# Line 905  run_install_normal() Line 681  run_install_normal()
681  {  {
682   dialog_hardware_detection   dialog_hardware_detection
683    
684   dialog_setup_hdd_partitions_manuell   dialog_setup_hdd_partitions_manual
685   dialog_setup_hdd_format   dialog_setup_hdd_format
686   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
687   install_mount_rootfs   install_mount_rootfs
688   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
689    
690   dialog_install_settings   dialog_install_settings
691   sleep 1   sleep 1
692   install_system_settings   install_system_settings
693   install_initrd_chroot   if is_initrd_supported
694     then
695     dialog_install_initrd
696     initrd_config
697     initrd_install
698     fi
699    
700   dialog_install_bootsector   dialog_install_bootsector
701   install_bootsector_chroot   bootloader_config
702     bootloader_install
703    
704   install_umount_rootfs   install_umount_rootfs
705   dialog_install_successful   dialog_install_successful
706  }  }
707    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
708  run_install_auto()  run_install_auto()
709  {  {
710   dialog_hardware_detection   dialog_hardware_detection
711    
712   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
713   dialog_setup_hdd_format   dialog_setup_hdd_format
714   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
715   install_mount_rootfs_flash   install_mount_rootfs
716   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
717    
718   dialog_install_settings   dialog_install_settings
719   sleep 1   sleep 1
720   install_system_settings_flash   install_system_settings
721   install_initrd_chroot   if is_initrd_supported
722     then
723     dialog_install_initrd
724     initrd_config
725     initrd_install
726     fi
727    
728   dialog_install_bootsector   dialog_install_bootsector
729   install_bootsector_chroot   bootloader_config
730     bootloader_install
731    
732   install_umount_rootfs_flash   install_umount_rootfs
733   dialog_install_successful   dialog_install_successful
734  }  }
735    
736    # set some proper traps
737    trap "trap_exit" SIGINT SIGQUIT
738    
739  dialog_main  dialog_main
740    
741  exit 0  exit 0

Legend:
Removed from v.2322  
changed lines
  Added in v.2472